#ifndef CAPABILITIES_H
#define CAPABILITIES_H

#include "gmc-miscellaneous_global.h"

#include <QString>
#include <QList>

//******************************************************************************

class TreeNode;

class GMCMISCELLANEOUSSHARED_EXPORT CapabilitiesComponent
{

public:

    CapabilitiesComponent();
    CapabilitiesComponent( int /*digit*/
                         , const QString & /*capability*/
                         , const QString & /*description*/
                         , const QString & /*shortName*/ = QString() );

    CapabilitiesComponent( const CapabilitiesComponent & );
    ~CapabilitiesComponent();
    const CapabilitiesComponent & operator=( const CapabilitiesComponent & );

    int digit() const;

    const QString &capability() const;
    const QString &description() const;
    const QString &shortName() const;

protected:

    int _digit;
    QString _capability;
    QString _description;
    QString _shortName;

};

//******************************************************************************

class GMCMISCELLANEOUSSHARED_EXPORT Capabilities
{

public:

    Capabilities();
    ~Capabilities();

    QList<TreeNode *> createCapabilitiesComponentTreeNodes();
    QString maskToString( int /*mask*/ ) const;

protected:

    QList< CapabilitiesComponent > _components;

};

//******************************************************************************

#endif
