#ifndef CHECKABLETREEPROXYMODEL_H
#define CHECKABLETREEPROXYMODEL_H

#include "gmc-miscellaneous_global.h"

#include <QPersistentModelIndex>
#include <QSortFilterProxyModel>
#include <QHash>

class GMCMISCELLANEOUSSHARED_EXPORT CheckableTreeProxyModel : public QSortFilterProxyModel
{
    Q_OBJECT

public:
    CheckableTreeProxyModel(QObject *parent = nullptr);

    QVariant data(const QModelIndex &index, int role) const override;
    bool setData(const QModelIndex &index, const QVariant &value, int role) override;
    Qt::ItemFlags flags(const QModelIndex &index) const override;
    void setSourceModel(QAbstractItemModel *sourceModel) override;

    QModelIndexList checkedList() const;

public slots:
    void reset();
    void invalidateFilterAndData();

signals:
    void someCheckedStateChenged();

private:
    void checkAllChildrenIfParentChecked(const QModelIndex &parent);
    void uncheckAllChildfree(const QModelIndex &parent, bool recursive = true);
    void setCheckedState(const QModelIndex &index);
    void setUncheckedState(const QModelIndex &index);
    void sendDataChangedSignal(const QModelIndexList &indexes);

    mutable QHash<QPersistentModelIndex, Qt::CheckState> m_indexHash; // can contain only CheckState and PartiallyChecked
};

#endif // CHECKABLETREEPROXYMODEL_H
