#ifndef MISCELLANEOUSELEMENT_H
#define MISCELLANEOUSELEMENT_H

#include "gmc-miscellaneous_global.h"

#include <element.h>

//******************************************************************************

class GMCMISCELLANEOUSSHARED_EXPORT UsersElement : public ContainerElement
{

    Q_OBJECT

public:

    enum ElementColumnsType { NameColumn = ElementRootTreeNode::_CountColumns
                            , UidColumn
                            , GecosColumn
                            , GroupColumn
                            , TypeColumn
                            , HomeColumn
                            , ShellColumn
                            , _CountColumns };

    UsersElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~UsersElement();

    int columnCount() const override;
    QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const override;

    qulonglong availableOperations() const override;

    QList< QString > displayChildrenVariants() const override;

};

//******************************************************************************

class GMCMISCELLANEOUSSHARED_EXPORT UserElement : public OrdinaryElement
{

    Q_OBJECT

public:

    UserElement( Module & /*module*/
               , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~UserElement();

    QVariant data( int /*column*/, int /*role*/ = Qt::DisplayRole ) const override;
    int treeNodeSpecialFlags() const override;

};


//******************************************************************************

class GMCMISCELLANEOUSSHARED_EXPORT GroupsElement : public ContainerElement
{

    Q_OBJECT

public:

    enum ElementColumnsType { NameColumn = ElementRootTreeNode::_CountColumns
                            , GidColumn
                            , TypeColumn
                            , _CountColumns };

    GroupsElement( Module & /*module*/
                 , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~GroupsElement();

    int columnCount() const override;
    QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const override;

    qulonglong availableOperations() const override;

    QList< QString > displayChildrenVariants() const override;

};

//******************************************************************************

class GMCMISCELLANEOUSSHARED_EXPORT GroupElement : public OrdinaryElement
{

    Q_OBJECT

public:

    GroupElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~GroupElement();

    QVariant data( int /*column*/, int /*role*/ = Qt::DisplayRole ) const override;

};

//******************************************************************************

#endif // MISCELLANEOUSELEMENT_H
