#ifndef MISCELLANEOUSELEMENTDATA_H
#define MISCELLANEOUSELEMENTDATA_H

#include "gmc-miscellaneous_global.h"

#include <QtGlobal>
#include <QDate>
#include <QSet>

#include <elementdata.h>

//******************************************************************************

//public:

class GMCMISCELLANEOUSSHARED_EXPORT UserElementData : public ElementData
{

public:

    UserElementData();
    UserElementData( const UserElementData & /*elementData*/ );
    virtual ~UserElementData();

    const UserElementData & operator=( const UserElementData & /*elementData*/ );

    int uid() const;
    void setUid(int uid);

    int gid() const;
    void setGid(int gid);

    const QString & gecos() const;
    void setGecos(const QString &gecos);

    const QString &group() const;
    void setGroup(const QString &group);

    const QString & home() const;
    void setHome(const QString &home);

    bool createHome() const;
    void setCreateHome(bool createHome);

    const QString & shell() const;
    void setShell(const QString &shell);

    bool pgsqlAccountCreate() const;
    void setPgsqlAccountCreate(const bool value);

    bool pgsqlAccountDelete() const;
    void setPgsqlAccountDelete(const bool value);

protected:

    int _uid;
    int _gid;
    QString _gecos;
    QString _group;
    QString _home;
    bool _createHome;   //only update & delete
    QString _shell;

    bool _pgsqlAccountCreate;
    bool _pgsqlAccountDelete;

};

//******************************************************************************

class GMCMISCELLANEOUSSHARED_EXPORT UserHeavyElementData : public UserElementData
{

public:

    UserHeavyElementData();
    UserHeavyElementData( const UserHeavyElementData & /*elementData*/ );
    virtual ~UserHeavyElementData();

    const UserHeavyElementData & operator=( const UserHeavyElementData & /*elementData*/ );

    const QString &skelDir() const;
    void setSkelDir(const QString &skelDir);

    QSet<QString> &addGroups();
    QSet<QString> &removeGroups();

protected:

    QString _skelDir;

    QSet< QString > _addGroups;      // availible or sites to add
    QSet< QString > _removeGroups; // enabled or sites to remove
};

//******************************************************************************


#endif // MISCELLANEOUSELEMENTDATA_H
