#ifndef MISCELLANEOUSTREENODESE_H
#define MISCELLANEOUSTREENODESE_H

#include "gmc-miscellaneous_global.h"

#include <treenode.h>

//******************************************************************************

class GMCMISCELLANEOUSSHARED_EXPORT CapabilitiesComponentRootTreeNode : public TreeNode
{

    Q_OBJECT

public:

    enum CapabilitiesComponentColumnsType { NameColumn
                                          , DigitColumn
                                          , _CountColumns };

    CapabilitiesComponentRootTreeNode( QObject * /*parent*/ = nullptr );
    virtual ~CapabilitiesComponentRootTreeNode();

    int columnCount() const override;
    QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const override;
};

//******************************************************************************

class GMCMISCELLANEOUSSHARED_EXPORT CapabilitiesComponentTreeNode : public TreeNode
{

    Q_OBJECT

public:

    CapabilitiesComponentTreeNode( const QString & /*name*/
                                 , const QString  & /*description*/
                                 , int /*digit*/
                                 , QObject * /*parent*/ = nullptr );
    virtual ~CapabilitiesComponentTreeNode();

    QVariant data( int /*column*/, int /*role*/ = Qt::DisplayRole ) const override;

protected:

    QString _name;
    QString _description;

    int _digit;
};

//******************************************************************************

#endif
