#ifndef TIMEINTERVALEDIT_H
#define TIMEINTERVALEDIT_H

#include "gmc-miscellaneous_global.h"

#include <QWidget>

namespace Ui {
class TimeIntervalEdit;
}

#define TIMEINTERVALEDIT_DEFAULT_MIN 0
#define TIMEINTERVALEDIT_DEFAULT_MAX 31536000
#define TIMEINTERVALEDIT_DEFAULT_VAL 0

class GMCMISCELLANEOUSSHARED_EXPORT TimeIntervalEdit : public QWidget
{
    Q_OBJECT

signals:

    void editingFinished();
    void valueChanged( uint );

protected:

    static uint toSeconds( uint days, uint hours, uint minutes );
    static uint toDays( uint seconds );
    static uint toHours( uint seconds );
    static uint toMinutes( uint seconds );
    static uint toDaysDigit( uint seconds );
    static uint toHoursDigit( uint seconds );
    static uint toMinutesDidit( uint seconds );


public:

    explicit TimeIntervalEdit(QWidget *parent = nullptr);
    virtual ~TimeIntervalEdit();

    uint value() const;

    uint minimum() const;
    void setMinimum( uint /*minimum*/ );

    uint maximum() const;
    void setMaximum( uint /*maximum*/ );

    bool isLocked() const;


public slots:

    void setValue( uint value );
    void clear();
    void setLocked( bool isLocked );

protected:

    void setSpinBoxesBlocked( bool /*blocked*/ );
    void setSpinBoxesEnabled( bool /*enabled*/ );

    void valueToWidget();   //block signal from spinBoxes
    uint widgetToValue() const;
    void valueToMinMax();

protected slots:

    void changeValue();

private:

    Ui::TimeIntervalEdit *_ui;

    bool _isLocked;

    uint _value;
    uint _minimum;
    uint _maximum;

};

#endif // TIMEINTERVALEDIT_H
